//A simple external component which demonstrates use of Unicode
//June 2009
//-------------------------------------------------------------

#include "stdafx.h"
#include "uTest.h"
#include <time.h>

qoschar *DEF_VERSION= (qoschar *)QTEXT("This text has been converted from Utf16/Utf8");  //A sample string of qoschars
qchar buffer[256];	//Used to store our test string


HINSTANCE    hInstLib=NULL;
HWND		 hwndTopWindow=NULL;
HWND		 hwndHWND=NULL;


enum {
	ENUM_Test_Unicode =1,
	ENUM_Test_GetText,
	ENUM_Test_SetText
     };


BOOL APIENTRY DllMain( HINSTANCE hInst, DWORD reason, LPVOID reserved)
{
		if(reason == DLL_PROCESS_ATTACH )
			hInstLib=hInst;   //Save hInstance
	
		return TRUE;
}

// Our dispatcher/entrypoint 
short WINAPI Test_Unicode ( short md, LPVOID ref, HWND hwnd, HWND topwindow, HINSTANCE instance, oproc callback)
{
 short packid;
 switch (md)
 {   case ext_load:
		break;
     case ext_unload:
		break;
     case ext_designsetup:
        packid = GetPackageIndex ( callback );
        if (packid != ENUM_Test_Unicode)
            DesignSetup( true, callback);
        else
            DesignSetup( false, callback);
        break;
     case ext_designinfo:
	        DesignInfo(callback);
        break; 
     case ext_call:                               
				if(topwindow)
					{
						hwndTopWindow=topwindow;
						Do_Test_Unicode(topwindow,callback);
					}
				else 
					if(hwnd)
						{
							hwndHWND=hwnd;
							Do_Test_Unicode(hwnd,callback);
						}
				break;
 }
 return 0;
}

void DesignSetup(short bDoReturn, oproc callback)
{
    long setupinfo = GetDesignPtr(callback);
}

//Return design-time information about our functions to Omnis
void DesignInfo(oproc callback)
{
	_extdesigninforec far *extinfo;
	char  buffer[255] = ""; 			
	char  *startptr;
	char  *endptr;
	short length,index;
	UINT  strid = FIRST_STR - 1;	
		

		extinfo = (_extdesigninforec far *)GetDesignPtr(callback);
		if (extinfo) 
		{
			extinfo->usedefault = false;
			if (extinfo->qfldid == CalcLabel) 
			{   
				index = (short) GetPackageIndex(callback);	 
				strid += index;
				LoadStringA(hInstLib, strid, buffer, 256); 
				startptr = strchr(buffer, '(');
				endptr = strrchr(buffer, ')');      
				length = (short) (endptr - startptr + 1);
				if ((length > 0) && (startptr) && (endptr)) 
				{
					#ifdef isunicode //For the Unicode target- convert from ASCII to Utf32
					*++endptr = '\0'; //add null terminator
						CHRcopyAsciiStringToQchar(startptr, extinfo->lable+1, qtrue);
					#else //Otherwise just copy the ASCII text to the label buffer
						OMstrncpy((qchar *)extinfo->lable+1, (qchar *)startptr, length); 
					#endif
					*(extinfo->lable) = (char)length; 
				}
			} 
			else 
			{
				index = (short) GetPackageIndex(callback);	 
				strid += index;
				LoadStringA(hInstLib, strid, buffer, 256); 	
				startptr = strchr(buffer, '{');
				endptr = strrchr(buffer, '}');      
				length = (short) (endptr - startptr + 1);
				if ((length > 0) && (startptr) && (endptr)) 
				{
					#ifdef isunicode //For the Unicode target- convert from ASCII to Utf32
						*++endptr = '\0'; //add null terminator
						CHRcopyAsciiStringToQchar(startptr, extinfo->lable+1, qtrue); 
					#else 
						OMstrncpy((qchar *)extinfo->lable+1, (qchar *)startptr, length); 
					#endif
					*(extinfo->lable) = (char)length; 
				}
			}
    }
}

void Do_Test_Unicode(HWND hWnd,oproc callback)
{ short   packindex; 	

	packindex = GetPackageIndex (callback);
	switch (packindex) 
	{
		case ENUM_Test_Unicode:
			Test_Proc1 (callback);
			break;
		case ENUM_Test_GetText:
			Test_Get_Text(callback);
			break;
		case ENUM_Test_SetText:
			Test_Set_Text(callback);
			break;
		default:
			break;
	}
}

//Set the buffer contents from the supplied FldVal
void Test_Set_Text (oproc callback)
{   
	qoschar TestStr[256]; //create a temporary buffer
	OMmemset((qbyte *)TestStr,0,sizeof(TestStr));

	//Get the text for parameter1 as a string of qoschars
	GetFldVal(ref_parm1,fmt_costring,sizeof(TestStr),TestStr,callback);
	//Now convert to qchars
	#ifdef isunicode
		qlong TestLen = CHRoscharToChar(&TestStr[0], &buffer[0]);
	#endif

	//Note: this is equivalent to getting the text as a string of qchars
	GetFldVal(ref_parm1,fmt_cstring,sizeof(buffer),&buffer[0],callback);
}

//Return strings in different Unicode encodings to Omnis
void Test_Proc1 (oproc callback)
{   
	time_t rawtime;		time( &rawtime ); //Get the system time
	struct tm *timeinfo = localtime ( &rawtime );
	char *mytime = asctime (timeinfo);
	CHRcopyAsciiStringToQchar(mytime, &buffer[0], qtrue); //convert ASCII to qchars

	SetFldVal (ref_parm1 ,fmt_costring, DEF_VERSION, callback); //set from a string of qoschars
	SetFldVal (ref_parm2 ,fmt_cstring, &buffer[0] ,callback);  //set from a string of qchars
}

//Return contents of the buffer to Omnis
void Test_Get_Text (oproc callback)
{   
	SetFldVal (ref_parm1 ,fmt_cstring, &buffer[0] ,callback); //set buffer as a string of qchars
}


